/*
 * @(#)BasicDataSource.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */
 /**
 * <P> A simple helper class  for the QueryNavigator class. In order to
 easily work with a mediatorDS a Data Source should implement this interface
 */
package symantec.itools.db.beans.binding;

public interface BasicDataSource
{

     /**
     * Sets the Mediator property.
     *This method allows the QueryNavigator to access the commit() method in
     *its MediatorDS. This commit() method is to be called whenever the
     *QueryNavigator wants to notify the DataBus a change in its values.
     *
     *   you should put it at the end of every next, previous.....
     *
     * @param mediat.     The reference to the MediatorDs.
     */
    //public void setMediator(MediatorDS mediat);

    /**
     * Gets the object stored in the QueryNavigator with the coordinates
     * row  and col.
     * @param    Row.       The current row, relative value.
     * @param    Col.       The column value.
     * @return   Object.    The value of the object.
     */
    public Object getValue(int Row,int Col);

    /**
     * Sets the object stored in the QueryNavigator with the coordinates
     * row  and col.
     * @param    Value.    The value of the object.
     * @param    Row.     The current row, relative value.
     * @param    Col.      The column value.
     *
     */
    public void setValue(Object Value,int Row,int Col) ;
    /**
     * Adds a listner for the trigger mothod of the data source. every data source sould be
     * connected to only one mediatords therefore the vector of listeners should contain only
     * one element. this vector of listeners is also used for setting the name of the mediatords's
     * DataName.
     */
    public void addTriggerUIListener(TriggerUIListener mds);
     /**
     * Removes a listner for the trigger mothod of the data source. every data source sould be
     * connected to only one mediatords therefore the vector of listeners should contain only
     * one element. this vector of listeners is also used for setting the name of the mediatords's
     * DataName.
     */
    public void removeTriggerUIListener(TriggerUIListener mds);
    public int getTotalNumberOfRows();
    public int getCurrentRowNumber();
}