/**
 * @(#)Connection.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

/**
 * This interface abstracts transaction support from common connection function.
 * Since the binding package is not limited to JDBC or any other data access API,
 * further connection function applicable only to JDBC does not appear in this interface.
 */
 
package symantec.itools.db.beans.binding;

public interface Connection
{
    /**
     * Start a transaction.
     */
    public void beginTransaction();
    
    /**
     * End a transaction.
     *
     * @param boolean commit
     */
    public void endTransaction(boolean commit);

    /**
     * Is every persistence operation an atomic transaction.
     */
    public boolean isAutoCommit();
}