/*
 * Copyright (c) 1997 Krumel & Associates, Inc. All Rights Reserved.
 *
 * www.krumel.com - controls@krumel.com
 *
 * Permission is given to the buyer of this package for one software
 * developer to use this software on one CPU (one workstation) and to make
 * one backup copy.  You may uitilize and/or modify this class for use in your
 * projects.  You may distribute or sell any executable which results from
 * using this code in yur application, except a utility or class of similar
 * nature to this product.  You may distribute this product in compiled
 * form only, but soley to be used with your cmpiled executable product
 * for the puposes of dynamic loading. You may NOT redistribute the source
 * code in any form or make it accessible through a network or other
 * distribution media to others. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * The source code is the confidential and proprietary information
 * of Krumel & Associates, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Krumel & Associates, Inc..

 * KRUMEL & ASSOCIATES MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE
 * SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT
 * NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. KRUMEL & ASSOCIATES SHALL NOT
 * BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
 * MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package symantec.itools.db.awt;


/**
 * This class represents a coordinate in a grid system or rows and columns.
 */
public class Coordinate implements java.io.Serializable {
    /**
     * The row of the coordinate.
     */
    public int row;
    /**
     * The column of the coordinate.
     */
    public int col;

    /**
     * Default constructor that creates a coordinate at row=0 and column=0.
     */
    public Coordinate() {}

    /**
     * Copy constructor.
     */
    public Coordinate(Coordinate c) {
        this(c.row, c.col);
    }

    /**
     * Creates a coordinate that is placed at the specified row and column position.
     * @param r The coordinate row.
     * @param c The coordinate column.
     */
    public Coordinate(int r, int c) {
        row = r;
        col = c;
    }

    /**
     * Compares this coordinate with another object and returns true if it is a
     * coordinate with the same points.
     */
    public boolean equals(Object o) {
        if (!(o instanceof Coordinate)) {
            return false;
        }

        Coordinate c = (Coordinate)o;
        return row == c.row && col == c.col;
    }

    /**
     * Changes the row to a new value.
     */
    public void setRow(int r) { row = r; }

    /**
     * Changes the column to a new value.
     */
    public void setCol(int c) { col = c; }

    /**
     * Get the row of the coordinate.
     */
    public int row() { return row; }

    /**
     * Get the column of the coordinate.
     */
    public int col() { return col; }

    /**
     * Gets a string representation of the coordinate.
     */
    public String toString() {
        return "Coordinate: row=" + row + " col=" + col;
    }
}