/*
 * @(#DataBusEventListener.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

package symantec.itools.db.beans.binding.databus;
public interface DataBusEventListener
{

 //This method is called in order to inform an IB component of the coming or going of data items. The
 //data item name is passed as a hint, and may be used in a subsequent requestDataItem() call. Note that
 //it is possible (but unusual) that a subsequent call to requestDataItem() may fail even though the listener
 //has "just" been informed of the new data item.
public void handleDataBusEvent(DataBusEvent e);


 //DataBusEventListeners are called by this method to see if they can fulfill a request for a data item. Note
 //that solicitations for new data may arrive at any time. A source may respond to requests for data items
 //which it did not announce (for example, a spreadsheet may respond to a request for item named
 //"A1..B10", even though it may never have announced the availability of such an item).

 //Components that are not acting in the role of data source may ignore these events by implementing an
 //empty requestDataItem() method.
public  void requestDataItem(DataBusEvent e);

}