/*
 * @(#DataMask.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */


package symantec.itools.db.awt;


/**
 * Creates a formatted text field in which your user can type in a date.
 * DateMask limits the type of text that can be entered in the text
 * box to a year-mo-day format number.
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 */
public class DateMask extends symantec.itools.db.awt.FormattedTextField
{
    /**
     * Create date text field.  This is a formatted text field
     * with the following format: 9999/-99/-99
     */
    public DateMask()
    {
        super(10);
        super.setMask("9999/-99/-99");
    }

    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the date mask.
     */
    public void setMask(String s)
    {
    }
}
