/*
 * Copyright (c) 1997 Krumel & Associates, Inc. All Rights Reserved.
 *
 * www.krumel.com - controls@krumel.com
 *
 * Permission is given to the buyer of this package for one software
 * developer to use this software on one CPU (one workstation) and to make
 * one backup copy.  You may uitilize and/or modify this class for use in your
 * projects.  You may distribute or sell any executable which results from
 * using this code in yur application, except a utility or class of similar
 * nature to this product.  You may distribute this product in compiled
 * form only, but soley to be used with your cmpiled executable product
 * for the puposes of dynamic loading. You may NOT redistribute the source
 * code in any form or make it accessible through a network or other
 * distribution media to others. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * The source code is the confidential and proprietary information
 * of Krumel & Associates, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Krumel & Associates, Inc..

 * KRUMEL & ASSOCIATES MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE
 * SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT
 * NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. KRUMEL & ASSOCIATES SHALL NOT
 * BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
 * MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package symantec.itools.db.awt;

/**
 * Class responsible to DbDataSource to make the necessary calls to update the database
 * to the state of the data stored in the data source.
 */
public interface DbDataUpdater extends java.io.Serializable {
    /**
     * Called by DbDataSource to allow the updater to store a reference to the data source.
     */
    public void setDbDataSource(DbDataSource ds);

    /**
     * Called by the data source when a row is marked for deletion.
     * @exception TypeNotSupported
     * if the data source does not support the type of action requested
     * or is not successful
     */
    public void deleteRow(int row) throws TypeNotSupported;
    /**
     * Called by the data source when a row is marked for undeletion.
     * @exception TypeNotSupported
     * if the data source does not support the type of action requested
     * or is not successful
     */
    public void undeleteRow(int row) throws TypeNotSupported;
    /**
     * Called by the data source when the user requests the data be saved back
     * to the database.
     * @exception TypeNotSupported
     * if the data source does not support the type of action requested
     * or is not successful
     */
    public void save() throws TypeNotSupported;
    /**
     * Called by the data source when the user requests to insert a row of data.
     * @exception TypeNotSupported
     * if the data source does not support the type of action requested
     * or is not successful
     */
    public void insertRow(int row) throws TypeNotSupported;
    /**
     * Called by the data source when the user requests to append a row of data.
     * @exception TypeNotSupported
     * if the data source does not support the type of action requested
     * or is not successful
     */
    public int appendRow() throws TypeNotSupported;
}
