/*
 * @(#LongZipCodeMask.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */


package symantec.itools.db.awt;

/**
 * Creates a formatted text field in which your user can type in a 9-digit zip
 * code.
 * LongZipCodeMask limits the type of text that can be entered in the text
 * box to a #####-#### format number.
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 */
public class LongZipCodeMask extends symantec.itools.db.awt.FormattedTextField
{
    /**
     * Constructs a long zip code field.  This is a formatted text field
     * with the following format: 99999/-9999
     */
    public LongZipCodeMask()
    {
        super(10);
        super.setMask("99999/-9999");
    }

    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the long zip code mask.
     */
    public void setMask(String s)
    {
    }
    
}
