/*
 * @(#MutableImmediateAccess.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

package symantec.itools.db.beans.binding.databus;

public interface MutableImmediateAccess extends ImmediateAccess
{
    public void setValue(ImmediateAccess newValue);

     // This method sets a new value for the immediate data in this object. The argument is an
     //ImmediateAccess object, which provides the required access methods for getting the new value. The
     //implementation must obtain the new value from the argument object before returning, rather than saving
     //a reference to it, because the caller may change its value after the return. In obtaining the new value
     //from the argument, the provider's implementation may need to make a deep (recursive) copy of the
     //new value to get all values changed by the consumer.

     //If the implementation supports change notifications, it should notify those listening for changes before
     //returning from setValue.
}