/*
 * @(#NavigationalDataSource.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

package symantec.itools.db.beans.binding;

import java.sql.SQLException;

public interface NavigationalDataSource extends BasicDataSource
{
    public void first() throws PositionOutOfRangeException;
    public void previous() throws PositionOutOfRangeException;
    public void next() throws PositionOutOfRangeException;
    public void insert();
    public void startQueryByExample();
    public Object getCurrentObject();

    // navigation types
    final static int NEXT = 1;          // Navigate to next row
    final static int PREVIOUS = 2;      // Navigate to previous row
    final static int FIRST = 3;         // Navigate to first row
    final static int RESTART = 4;       // Restart and navigate to first row
    final static int GOTO = 5;          // Navigate to row x
    final static int QBE = 6;           // Navigate to qbe row
    final static int INSERT = 7;        // Navigate to new row

    void navigate(int type, Integer position);
    void executeQuery(Synchronizable master) throws SQLException;
}