/*
 * @(#)NewValue.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */
/**
 * <p>This class is used to change the value in the DataItem
 *
 */

package symantec.itools.db.beans.binding;
import symantec.itools.db.beans.binding.databus.*;
public class NewValue implements ImmediateAccess
{
    private Object Value;
   /**
    * Constructor, creates a newValue object from an Object. This object contains a new array of
    * objects.
    * @param value. the value of the newValue Object
    */
    public NewValue(Object value)
    {
        try
        {
            Value=value;
        }
        catch(Exception e)
        {
            Value=value;
        }
    }
   /**
    * returns the value of the newValue as a String.
    * @return String. value of the Object
    */
    public String getValueAsString()
    {
        return((String)Value.toString());
    }
    /**
    * returns the value of the newValue as a Object.
    * @return Object. value of the Object
    */
    public Object getValueAsObject(){
        if(Value==null)return null;
        return((Object)Value);
    }
    public String getPresentationString(){
        return("String");
    }
    public synchronized void addDataItemChangedListener(DataItemChangedListener dcl){}
    public synchronized void removeDataItemChangedListener(DataItemChangedListener dcl){}

}