/*
 * @(#PersistentDataSource.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

package symantec.itools.db.beans.binding;

import java.sql.SQLException;

public interface PersistentDataSource
{
    public void save();
    public int saveAll();
    public void setMarkedAsDeleted();
    public void undoChanges();
   // public void startQueryByExample();
   // public void executeQueryByExample();

    // dirty data resolutions
    public final static int SAVE_DELETED_DIRTY_DATA = 1;   // Issue DELETE DML
    public final static int SAVE_ALL_DIRTY_DATA = 2;       // Issue INSERT/UPDATE DML
    public final static int CLEAR_ALL_DATA = 4;            // Throw away all data
    public final static int  SAVE_CURRENT_RECORD=5;
    public int saveAll(int resolution) throws SQLException;
    public boolean isDirty();
    public void commitState();
    public Connection getConnection();
    
    public boolean isEmpty();
}