/*
 * @(#PersistentObject.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

package symantec.itools.db.beans.binding;

public interface PersistentObject
{

    final static int ORIGINAL_VALUE=0;
    final static int MODIFIED_VALUE=1;


    public int getValueIndex(String name);

    //adiacon 07.29
    // we can ask the original value or the modified value, but
    //we can only set the modified value
    public void initDataStorage();
    public Connection getConnection();
    public String getValueAsString(int index, int orig_mofif_value);
    public Object getValueAsObject(int index, int orig_mofif_value);
    public void setValueAsString(int index, String value);
    public void setValueAsInteger(int index, Integer value);
    public void setValueAsObject(int index, Object value);
    public int getColumnIndex(String name);
    public java.util.Enumeration querySimilarObjects();
    public java.util.Enumeration querySimilarObjects(String whereClause,String[] sortOrder) throws Exception;
    public java.util.Enumeration querySimilarObjects(String whereClause,Synchronizable.JoinRecordList joinList,String[] sortOrder) throws Exception;
    public int save();
    public void undoChanges();
    public boolean getMarkedAsNew();
    public boolean getMarkedAsDeleted();
    public boolean getMarkedAsModified();
    public boolean getMarkedAsMisplaced();
    public void setMarkedAsNew(boolean markedAsNew);
    public void setMarkedAsDeleted(boolean markedAsDeleted);
    public void setMarkedAsModified(boolean markedAsModified);
    public void setMarkedAsDisplaced(boolean markedAsModified);
    public void resetState();
    public boolean isDirty();
    public String getDataName(String pattern);
    public class RecordException extends RuntimeException
    {}

    public PersistentObjectModel getDataModel();
}