/*
 * @(#RowMetaData.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

package symantec.itools.db.beans.jdbc;

import java.util.*;
import symantec.itools.db.beans.binding.*;

public class RowMetaData implements PersistentObjectModel
{
    boolean isPrimaryKeyOrIndex=false;

    public RowMetaData() {
        // System.out.println("Constructing RowMetaData");
    }

    // PersistentObjectModel interface methods...

    public String getModelName()
    {
        return getTableName();
    }

    public int getMemberCount()
    {
        return getColumnCount();
    }

    public PersistentObjectMemberModel getMemberModel(int memberIndex)
    {
        return getColumnMetaData(memberIndex);
    }

    // End of PersistentObjectModel interface methods.

    public String m_TableName;
    public boolean isPrimaryKeyOrIndex() {
        return isPrimaryKeyOrIndex;
    }
    public void setIsPrimaryKeyOrIndex(boolean value) {
        isPrimaryKeyOrIndex = value;
    }
    public String getTableName() {
        return m_TableName;
    }
    public void setTableName(String value) {
        m_TableName = value;
    }
    public Vector m_ColumnMetaData;

    public int getColumnCount() {
        if (m_ColumnMetaData != null) {
            return m_ColumnMetaData.size();
        }
        return 0;
    }
    public ColumnMetaData getColumnMetaData(int column) {
        Object obj = null;
        if (m_ColumnMetaData != null && m_ColumnMetaData.size() > column) {
            obj = m_ColumnMetaData.elementAt(column);
        }
        if (obj != null && obj instanceof ColumnMetaData) {
            return (ColumnMetaData)obj;
        }
        return null;
    }
    public void addColumnMetaData(ColumnMetaData cmd) {
        if (m_ColumnMetaData == null) {
            m_ColumnMetaData = new Vector();
        }
        m_ColumnMetaData.addElement(cmd);
    }
}

