/*
 * @(#SSNMask.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

package symantec.itools.db.awt;


/**
 * Creates a formatted text field in which your user can type in a
 * social security number.
 * This class limits the type of text that can be entered in the text box to a
 * ###-##-####
 * format number.
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 */
public class SSNMask extends symantec.itools.db.awt.FormattedTextField
{
    /**
     * Constructs a long zip code field.  This is a formatted text field
     * with the following format: 999/-99/-9999
     */
    public SSNMask()
    {
        super(11);
        super.setMask("999/-99/-9999");
    }

    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the long zip code mask.
     */
    public void setMask(String s)
    {
    }
}
