/*
 * @(#)Synchronizable.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

package symantec.itools.db.beans.binding;

import java.sql.SQLException;
import java.util.Enumeration;
import java.beans.PropertyChangeListener;

public interface Synchronizable extends PersistentDataSource, NavigationalDataSource
{
    String getAliasName();
    String getMasterAliasName();
    void setLink(SynchronizerLink link);
    
    public abstract class JoinRecordList{
        public abstract Enumeration getJoinRecords();
        
    };
    public abstract class JoinRecord{
        public abstract Object getMasterCurrentValue();
        public abstract String getDetailColumnName();
        public abstract int getDetailColumnNumber();
        public abstract String getOperator();
        
    };
    
    /**
     * javadoc comments go here...
     */
    public void addPropertyChangeListener(PropertyChangeListener listener);

    /**
     * javadoc comments go here...
     */
    public void removePropertyChangeListener(PropertyChangeListener listener);
}