/*
 * @(#)SynchronizerTree.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */

// Each QuerySynchronizer object contains one and only one
// QueryNavigatorTree object.  This tree class implements the JFC
// swing tree interface.  The parent child relationships between tree
// nodes correspond to the master detail relationships between
// QueryNavigators objects.  Each node contains a reference to a
// QueryNavigatorLink object.  The purpose of this link is to hold
// a spot for a QueryNavigator when the alias is known from a detail
// QueryNavigator object before the master QueryNavigator object is
// registered.

package symantec.itools.db.beans.binding;

import javax.awt.swing.tree.*;

final class SynchronizerTree extends DefaultTreeModel
{
    SynchronizerTree(TreeNode root)
    {
        super(root);
    }

    synchronized QuerySynchronizer getSynchronizer()
    {
        return m_Synchronizer;
    }

    synchronized void setSynchronizer(QuerySynchronizer sync)
    {
        m_Synchronizer = sync;
    }

    private QuerySynchronizer m_Synchronizer = null;
}