/*
 * @(#TimeMask.java
 *
 * Copyright (c) 1997 Symantec Corporation. All Rights Reserved.
 *
 */


package symantec.itools.db.awt;

/**
 * Creates a formatted text field in which your user can type in the
 * time.
 * This class limits the type of text that can be entered in the text box to a
 * HH-MM-SS
 * format number.
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 */
public class TimeMask extends symantec.itools.db.awt.FormattedTextField
{
    /**
     * Constructs a long zip code field.  This is a formatted text field
     * with the following format: 99/:99/:99
     */
    public TimeMask()
    {
        super(8);
        super.setMask("99/:99/:99");
    }

    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the long zip code mask.
     */
    public void setMask(String s)
    {
    }
}
